Package com.typesafe.config

# Class ConfigException

java.lang.Object
java.lang.Throwable
java.lang.Exception
java.lang.RuntimeException
com.typesafe.config.ConfigException

All Implemented Interfaces:
  `Serializable`

Direct Known Subclasses:
  `ConfigException.BadPath`, `ConfigException.BadValue`, `ConfigException.BugOrBroken`, `ConfigException.Generic`, `ConfigException.IO`, `ConfigException.Missing`, `ConfigException.Parse`, `ConfigException.ValidationFailed`, `ConfigException.WrongType`

public abstract class ConfigException extends RuntimeException implements Serializable
All exceptions thrown by the library are subclasses of `ConfigException`.

See Also:
  - Serialized Form

## Nested Class Summary

Nested Classes
Modifier and Type
Class
Description
`static class`
`ConfigException.BadBean`
Some problem with a JavaBean we are trying to initialize.
`static class`
`ConfigException.BadPath`
Exception indicating that a path expression was invalid.
`static class`
`ConfigException.BadValue`
Exception indicating that a value was messed up, for example you may have asked for a duration and the value can't be sensibly parsed as a duration.
`static class`
`ConfigException.BugOrBroken`
Exception indicating that there's a bug in something (possibly the library itself) or the runtime environment is broken.
`static class`
`ConfigException.Generic`
Exception that doesn't fall into any other category.
`static class`
`ConfigException.IO`
Exception indicating that there was an IO error.
`static class`
`ConfigException.Missing`
Exception indicates that the setting was never set to anything, not even null.
`static class`
`ConfigException.NotResolved`
Exception indicating that you tried to use a function that requires substitutions to be resolved, but substitutions have not been resolved (that is, `Config.resolve()` was not called).
`static class`
`ConfigException.Null`
Exception indicates that the setting was treated as missing because it was set to null.
`static class`
`ConfigException.Parse`
Exception indicating that there was a parse error.
`static class`
`ConfigException.UnresolvedSubstitution`
Exception indicating that a substitution did not resolve to anything.
`static class`
`ConfigException.ValidationFailed`
Exception indicating that `Config.checkValid(com.typesafe.config.Config, java.lang.String...)` found validity problems.
`static class`
`ConfigException.ValidationProblem`
Information about a problem that occurred in `Config.checkValid(com.typesafe.config.Config, java.lang.String...)`.
`static class`
`ConfigException.WrongType`
Exception indicating that the type of a value does not match the type you requested.

## Constructor Summary

Constructors
Modifier
Constructor
Description
`protected`
`ConfigException(ConfigOrigin origin, String message)`
`protected`
`ConfigException(ConfigOrigin origin, String message, Throwable cause)`
`protected`
`ConfigException(String message)`
`protected`
`ConfigException(String message, Throwable cause)`

## Method Summary

Modifier and Type
Method
Description
`ConfigOrigin`
`origin()`
Returns an "origin" (such as a filename and line number) for the exception, or null if none is available.

### Methods inherited from class java.lang.Throwable

`addSuppressed, fillInStackTrace, getCause, getLocalizedMessage, getMessage, getStackTrace, getSuppressed, initCause, printStackTrace, printStackTrace, printStackTrace, setStackTrace, toString`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

## Constructor Details

### ConfigException

protected ConfigException(ConfigOrigin origin, String message, Throwable cause)

### ConfigException

protected ConfigException(ConfigOrigin origin, String message)

### ConfigException

protected ConfigException(String message, Throwable cause)

### ConfigException

protected ConfigException(String message)

## Method Details

### origin

public ConfigOrigin origin()
Returns an "origin" (such as a filename and line number) for the exception, or null if none is available. If there's no sensible origin for a given exception, or the kind of exception doesn't meaningfully relate to a particular origin file, this returns null. Never assume this will return non-null, it can always return null.

Returns:
  origin of the problem, or null if unknown/inapplicable